/*
 * wifly.h
 *
 *  Created on: 21/10/2013
 *      Author: toni
 */

#ifndef WIFLY_H_
#define WIFLY_H_
#define rebutSIZE (200)

/*****************************************************************************
** Function name:		wiflyResetWifi
**
** Descriptions:		Reseteja el dongle wifi, per inicialitzar l'enllaç
** parameters:			None
** Returned value:		None
**
*****************************************************************************/
void wiflyResetWifi(void);

/*****************************************************************************
** Function name:		wiflyConnectTo
**
** Descriptions:		Es conecta a un punt d'acces
** parameters:			ssid:nom del punt d'acces
** 						pass: contrasenya del punt d'acces
** Returned value:		retorna 1 o 0 depenen si ha sigut satisfactori o no
**
*****************************************************************************/

int wiflyConnectTo(const char* ssid,const char* pass);

/*****************************************************************************
** Function name:		wiflybaudrate
**
** Descriptions:		Canvia la velocitat de transmissió del Wifi defecte 115200
** parameters:			cap
** Returned value:		cap
**
*****************************************************************************/
int wiflybaudrate(int baud_rate_uart);

/*****************************************************************************
** Function name:		wiflyTcpMode
**
** Descriptions:		Posa el mode TCP sense *HELLO*
** parameters:			cap
** Returned value:		cap
**
*****************************************************************************/

int wiflyTcpMode(void);

/*****************************************************************************
** Function name:		wiflyTcpOpen
**
** Descriptions:		Obre el socket TCP amb el servidor assignat
** parameters:			cap
** Returned value:		cap
**
*****************************************************************************/

int wiflyTcpOpen(void);

/*****************************************************************************
** Function name:		wiflyTcpOptions
**
** Descriptions:		Estableix els parametres del socket
** parameters:			cap
** Returned value:		cap
**
*****************************************************************************/
int wiflyTcpOptions(void);

/*****************************************************************************
** Function name:		wiflyPingTo
**
** Descriptions:		Envia una comanda ping a una ip determinada
** parameters:			ip: Ip desti on fara el ping
** Returned value:		retorna 1 o 0 depenen si ha sigut satisfactori o no
**
*****************************************************************************/

int wiflyPingTo(const char* ip);

/*****************************************************************************
** Function name:		wiflyParameters
**
** Descriptions:		Funcio que ens informa de la ip actual, el punt d'acces on estem
** 						conectats , el canal i el temps transcorregut de conexio
** parameters:			None
** Returned value:		retorna 1 o 0 depenen si ha sigut satisfactori o no
**
*****************************************************************************/
int wiflyParameters(void);

/*****************************************************************************
** Function name:		wiflyCommandesGet
**
** Descriptions:		Pertany a la llibreria liparplab , esta aqui per a la verificació
** 						en la correció
** parameters:			None
** Returned value:		retorna 1 o 0 depenen si ha sigut satisfactori o no
**
*****************************************************************************/
int wiflyCommandesGet(void);

/*****************************************************************************
** Function name:		wiflyCommandesPrintArp
**
** Descriptions:		Pertany a la llibreria liparplab , esta aqui per a la verificació
** 						en la correció
** parameters:			None
** Returned value:		retorna 1 o 0 depenen si ha sigut satisfactori o no
**
*****************************************************************************/
void wiflyCommandesPrintArp(int dada);

/*****************************************************************************
** Function name:		wiflySend
**
** Descriptions:		Envia un text mitjançant el dongle wifi
** parameters:			None
** Returned value:		None
**
*****************************************************************************/
void wiflySend(const char* string);
//int wiflyCommandaFeed(const char* GET);

/*****************************************************************************
** Function name:		wiflyConsultaPotencia
**
** Descriptions:		Consulta la potencia actual de enllaç
** parameters:			None
** Returned value:		Retorna la potencia actual de enllaç
**
*****************************************************************************/
uint32_t wiflyConsultaPotencia(void);

/*****************************************************************************
** Function name:		wiflyCanviarPotencia
**
** Descriptions:		Permet canviar el parametre de potencia de l'enllaç
** parameters:			Se li passa el parametre de potencia
** Returned value:		Retorna si ha sigut satisfactori
**
*****************************************************************************/
int wiflyCanviarPotencia(uint32_t potencia);

/*****************************************************************************
** Function name:		wiflyGetIp
**
** Descriptions:		Demana la IP actual del Dongle Wifi
** parameters:			None
** Returned value:		None
**
*****************************************************************************/
void wiflyGetIp(void);
/*****************************************************************************
** Function name:		wiflyGetChannel
**
** Descriptions:		Demana el canal actual del Dongle Wifi
** parameters:			None
** Returned value:		None
**
*****************************************************************************/
void wiflyGetChannel(void);

/*****************************************************************************
** Function name:		wiflyGetRSSI
**
** Descriptions:		Demana la força actual de la senyal
** parameters:			None
** Returned value:		retorna la potencia actual
**
*****************************************************************************/
int wiflyGetRSSI(void);

/*****************************************************************************
** Function name:		wiflyElapsedTime
**
** Descriptions:		Demana el temps transcorregut de conexio
** parameters:			None
** Returned value:		retorna el temps
**
*****************************************************************************/
int wiflyElapsedTime(void);
/*****************************************************************************
** Function name:		wiflyPrintOvertime
**
** Descriptions:		Mitjançant els parametres recollits internament per la funcio
** 						genera una impresio al llarg del temps representant una funció
** 						i enviades al arplab
**
** parameters:			None
** Returned value:		retorna si ha sigut satisfactori
**
*****************************************************************************/
int wiflyPrintOvertime(void);

#endif /* WIFLY_H_ */
