/*
 * gpioutils.c
 */
#include "FreeRTOS.h"
#include "LPC17xx.h"
#include "gpioutils.h"

void gpioutilsInit(int pin_register,int bit_register,int pin_mode,int address) {
	if(pin_register==0){
		LPC_PINCON->PINSEL0	&= ( ~( pin_mode << bit_register ) );
	}
	else if(pin_register==1){
		LPC_PINCON->PINSEL1	&= ( ~( pin_mode << bit_register ) );
	}
	else if(pin_register==2){
		LPC_PINCON->PINSEL2	&= ( ~( pin_mode << bit_register ) );
	}
	else if(pin_register==3){
		LPC_PINCON->PINSEL3	&= ( ~( pin_mode << bit_register ) );
	}
	else if(pin_register==4){
		LPC_PINCON->PINSEL4	&= ( ~( pin_mode << bit_register ) );
	}
	LPC_GPIO0->FIODIR |=(1<<address);

}
unsigned long gpioutilsState(int address){
	unsigned long ulState;
	/* Obte l'estat del PIN . */
	ulState = LPC_GPIO0->FIOPIN;
	return ulState;

}
void gpioutilsHigh(int address) {
	LPC_GPIO0->FIOSET = ( 1 << address ) ;
}
void gpioutilsLow(int address) {
	LPC_GPIO0->FIOCLR = ( 1 << address ) ;

}
