/*
 * menu.c
 *
 *  Created on: 04/05/2014
 *      Author: toni
 */
#include "LPC17xx.h"
#include "FreeRTOS.h"
#include "uart.h"
#include "printf.h"
#include "scanf.h"
#include "wifly.h"
#include "menu.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "commonutils.h"

char* teaser = "\n\n\nPAC3 wifly \r\n\nConectant...\r\n\n";


void MenuInici(void){
	uint8_t intents=0;
	Printf_UARTInit(LOGPORT, LOGBAUD);
	Printf_UARTInit(WIFIPORT, WIFIBAUD);
	commonutilsdelayMS(250);
	Printf_UART(LOGPORT,teaser);
	wiflyResetWifi();
	commonutilsdelayMS(3000);
	Printf_UART(LOGPORT,"Conecto a %s\r\n",SSID);
	while(intents<3){
		if (wiflyConnectTo(SSID, PASS) == 1) {
			Printf_UART(LOGPORT,"Intent de conexio a %s %d de 3 \r\n",SSID,intents);
			Printf_UART(LOGPORT,"La conexio ha sigut correcte\r\n");
			Printf_UART(LOGPORT,menu);
			break;
		} else {
			intents++;
			Printf_UART(LOGPORT,"La conexio no ha sigut correcte\r\n");
			Printf_UART(LOGPORT,"Reintentant Conectar %d de 3\r\n",intents);
			wiflyResetWifi();

		}
	}
}
void MenuLoop(void){
	for (;;) {
		char rebut[1];
		uint8_t ptx;
		uint32_t size;
		int commanda=0;
		memset(rebut, 0x00, 1);
		size=scanf_uart3(rebut,1000);
		if (size>0) {
			commanda = atoi(rebut);
			Printf_UART(3,"Commanda rebuda -> %s  \r\n", rebut);
			switch (commanda) {
			case 1:
				if (wiflyPingTo("8.8.8.8") == 1) {
				}
				Printf_UART(3,"%s", menu);
				commanda = 0;
				break;
			case 2:
				if (wiflyParameters() == 1) {
				}
				Printf_UART(3,"%s", menu);
				commanda = 0;
				break;
			case 3:
				if (wiflyCommandesGet() == 1) {
					Printf_UART(3,"%s", menu);
					commanda = 0;
				} else {
					Printf_UART(3,"%s", menu);
				}
				break;
			case 4:
				Printf_UART(3,"%s", "Consulta potencia \r\n");
				wiflyConsultaPotencia();
				Printf_UART(3,menu);
				commanda = 0;
				break;
			case 5:
				Printf_UART(3,"%s", "Canviar potencia a 3 \r\n");
				ptx = 3;
				if (wiflyCanviarPotencia(ptx) == 1) {
					Printf_UART(3,menu);
					commanda = 0;
				} else {
					Printf_UART(3,menu);
				}
				break;
			case 6:
				Printf_UART(3,"%s", "Apartat 5 de la Pac\r\n");
				int i;
				for(i=0;i<3;i++){
					wiflyPrintOvertime();
				}
				Printf_UART(3,menu);
				commanda = 0;
				break;

			}
		}
	}
}
