/*
 * printf.c
 *
 *  Created on: 12/11/2013
 *      Author: toni
 */

#include "LPC17xx.h"
#include "FreeRTOS.h"
#include "uart.h"
#include "semphr.h"
#include "type.h"
#include <string.h>
#include <stdarg.h>
#include <stdio.h>
#include <printf.h>
#include <commonutils.h>


/*http://c.conclase.net/librerias/?ansilib=stdarg#inicio acces a les noves funcionalitats*/
/*http://books.google.es/books?id=LFfhjnmEdyUC&pg=PA409&lpg=PA409&dq=usar+va_list&source=bl&ots=-tvQdor8pu&sig=IF5_UekPGimnsnTaAHkJ4bJE-Lo&hl=es&sa=X&ei=XsiUUojFBMz40gWsrIEg&ved=0CFQQ6AEwBQ#v=onepage&q=usar%20va_list&f=false*/

/*inicialitzacio de variables */

static xSemaphoreHandle Print_Mutex = NULL;

void Printf_UARTInit(address_uart, baud_rate_uart){
	UART0State=0;
	UART3State=0;
	Print_Mutex=xSemaphoreCreateMutex();
	xSemaphoreTake( Print_Mutex, portMAX_DELAY );{
		UARTInit(address_uart, baud_rate_uart);
		if(address_uart==0){
			UART0State=1;
		}
		else if(address_uart==3){
			UART3State=1;
		}

	}
	xSemaphoreGive( Print_Mutex );

}

void Printf_UART(uint8_t address_uart,char *cadena, ...)
{
	va_list args;
	va_start(args, cadena);
	static char buffer_intern[BUFSIZE] ;
	memset(buffer_intern, 0x00, BUFSIZE);
	vsprintf( buffer_intern, cadena, args ) ;
	UARTSend(address_uart, (uint8_t *)buffer_intern , strlen(buffer_intern) );
	UARTFlush(address_uart);
}



