/*
 * wifly.c
 *
 *  Created on: 21/10/2013
 *      Author: toni
 */

#include "config.h"
#include "libarplab.h"
#include "wifly.h"


extern volatile uint32_t UART3Count, UART0Count;
extern volatile uint8_t UART3Buffer[BUFSIZE], UART0Buffer[BUFSIZE];
int potencia, rssi, temps;
char rebut[rebutSIZE];
char parser[100];

static xSemaphoreHandle WiflyMutex = NULL;
void wiflyResetWifi(void) {
	WiflyMutex = xSemaphoreCreateMutex();
	xSemaphoreTake(WiflyMutex, portMAX_DELAY);
	{
		LPC_PINCON->PINSEL1 &= (~(3 << 12));
		LPC_GPIO0->FIODIR |= (1 << 22);
		LPC_GPIO0->FIOCLR = 1 << 22;
		commonutilsdelayMS(1);
		LPC_GPIO0->FIOSET = 1 << 22;
		commonutilsdelayMS(2000);
		Printf_UART(3, "Reset correcte\r\n");
	}
	xSemaphoreGive(WiflyMutex);
}
int wiflyModeCommanda(void) {

	xSemaphoreTake(WiflyMutex, portMAX_DELAY);
	{
		memset(rebut, 0x00, rebutSIZE);
		commonutilsdelayMS(3000);
		Printf_UART(3, "%s", "Entra a mode_commanda\r\n");
		do {
			Printf_UART(0, "$$$");
			commonutilsdelayMS(3000);
			scanf_uart0(rebut, 5000);
		} while (strcmp(rebut, "CMD\r\n") == 0);

	}
	xSemaphoreGive(WiflyMutex);
	return 1;
}
int wiflybaudrate( baud_rate_uart) {
	while (wiflyModeCommanda() != 1) {

	}
	xSemaphoreTake(WiflyMutex, portMAX_DELAY);
	{

		Printf_UART(0, "set uart baudrate 115200 \r\n");
		scanf_uart0(rebut, 250);
		Printf_UART(3, "wifi baudrate %d \r\nresposta %s\r\n", baud_rate_uart,
				rebut);
		Printf_UARTInit(0, baud_rate_uart);
		commonutilsdelayMS(1500);

	}
	xSemaphoreGive(WiflyMutex);
	wiflyModeCommanda();
	return 1;
}
int wiflyConnectTo(const char* ssid, const char* pass) {

	if (wiflyModeCommanda() == 1) {
		Printf_UART(3, "Mode Comanda ok \r\n");
		xSemaphoreTake(WiflyMutex, portMAX_DELAY);
		{
			char w_login[100], w_join[100];
			memset(rebut, 0x00, rebutSIZE); //clear de tot l'array sino malament
			memset(w_login, 0x00, 100);
			memset(w_join, 0x00, 100);
			strcpy(w_login, "set wlan phrase ");
			strcat(w_login, pass);
			strcat(w_login, "\r\n");
			strcpy(w_join, "join ");
			strcat(w_join, ssid);
			strcat(w_join, "\r\n");
			commonutilsdelayMS(1500);
			Printf_UART(0, "%s", w_login);
			commonutilsdelayMS(1500);
			Printf_UART(0, "%s", w_join);
			scanf_uart0(rebut, 4500);
		}
		xSemaphoreGive(WiflyMutex);
		if (strstr(rebut, "Associated!\r\n") != NULL) {
			commonutilsdelayMS(3000);
			return 1;

		} else {
			return 0;
		}
	} else {
		return 0;
	}
}
int wiflyTcpMode(void) {
	xSemaphoreTake(WiflyMutex, portMAX_DELAY);
	{
		memset(rebut, 0x00, rebutSIZE);
		Printf_UART(0, "set comm remote 0 \r\n");
		scanf_uart0(rebut, 1000);


	}
	xSemaphoreGive(WiflyMutex);
	if (strstr(rebut, "AOK\r\n")) {
		Printf_UART(3, " TCPMODE : OK %s \r\n", rebut);
		memset(rebut, 0x00, rebutSIZE);
		return 1;
	} else {
		memset(rebut, 0x00, rebutSIZE);
		return 0;
	}

}
int wiflyTcpOptions(void) {
	xSemaphoreTake(WiflyMutex, portMAX_DELAY);
	{
		memset(rebut, 0x00, rebutSIZE);
		Printf_UART(0, "set ip host %s\r\n",TCPSERVER);
		commonutilsdelayMS(50);
		scanf_uart0(rebut, 650);
		memset(rebut, 0x00, rebutSIZE);
		Printf_UART(0, "set ip remote %s\r\n",TCPPORT);
		commonutilsdelayMS(50);
		scanf_uart0(rebut, 650);

	}
	xSemaphoreGive(WiflyMutex);
	if (strstr(rebut, "AOK\r\n")!= NULL) {
		memset(rebut, 0x00, rebutSIZE);
		return 1;
	} else {
		return 0;
	}
}
int wiflyTcpOpen(void) {
	int state=0;
	xSemaphoreTake(WiflyMutex, portMAX_DELAY);
	{
		memset(rebut, 0x00, rebutSIZE);
		commonutilsdelayMS(50);
		Printf_UART(0, "open %s %s\r\n",TCPSERVER,TCPPORT);
		scanf_uart0(rebut, 50);
		if (strstr(rebut, "*OPEN*")!= NULL) {
			Printf_UART(3, " OPEN OK : %s \r\n", rebut);
			memset(rebut, 0x00, rebutSIZE);
			state = 1;
		} else {
			Printf_UART(3, "OPEN Fail: %s\r\n", rebut);
			memset(rebut, 0x00, rebutSIZE);
			state = 0;
		}
	}
	xSemaphoreGive(WiflyMutex);
	return state;
}
int wiflyTcpSend() {
	xSemaphoreTake(WiflyMutex, portMAX_DELAY);
	{
		memset(rebut, 0x00, rebutSIZE);
		scanf_uart0(rebut, 1);
		commonutilsdelayMS(100);
		if (strstr(rebut, "OPEN") != NULL) {
			Printf_UART(3, "%s", rebut);
			char message[] = "pitorro";
			Printf_UART(0, "set comm remote %s \r\n", message);
		}

	}
	xSemaphoreGive(WiflyMutex);
	return 1;
}
int wiflyPingTo(const char* ip) {

	xSemaphoreTake(WiflyMutex, portMAX_DELAY);
	{
		memset(rebut, 0x00, rebutSIZE); //clear de tot l'array sino malament
		char ping[100] = { };
		strcpy(ping, "ping ");
		strcat(ping, ip);
		strcat(ping, "\r\n");
		Printf_UART(3, "\r\n -> %s\r\n", ping);
		Printf_UART(0, ping);
		scanf_uart0(rebut, 1);
		Printf_UART(3, "Resposta del wifly\r\n");
		Printf_UART(3, "\r\n -> %s\r\n", rebut);
		return 1;
	}
	xSemaphoreGive(WiflyMutex);

}
int wiflyCommandesGet(void) {

	xSemaphoreTake(WiflyMutex, portMAX_DELAY);
	{
		int dada_recollida = 0;
		ArpalabInici();
		dada_recollida = ArplabGetDada();
		wiflyModeCommanda();
		return dada_recollida;
	}
	xSemaphoreGive(WiflyMutex);

}
void wiflyCommandesPrintArp(int dada) {

	xSemaphoreTake(WiflyMutex, portMAX_DELAY);
	{
		ArpalabInici();
		ArplabPrintGet(dada);
		wiflyModeCommanda();

	}
	xSemaphoreGive(WiflyMutex);
}
void wiflySend(const char* string) {

	xSemaphoreTake(WiflyMutex, portMAX_DELAY);
	{
		memset(rebut, 0x00, rebutSIZE); //clear de tot l'array sino malament
		int stringlen = strlen((char*) (string));
		char send[stringlen];
		strcat(send, string);
		Printf_UART(3, "\r\n Enviat per Wifly -> %s\r\n", send);
		Printf_UART(0, send);
		commonutilsdelayMS(250);
		scanf_uart0(rebut, 1);
		Printf_UART(3, "Rebut del wifly\r\n");
		Printf_UART(3, "\r\n -> %s\r\n", rebut);

	}
	xSemaphoreGive(WiflyMutex);

}

uint32_t wiflyConsultaPotencia() {

	xSemaphoreTake(WiflyMutex, portMAX_DELAY);
	{
		memset(parser, 0x00, 100);
		memset(rebut, 0x00, rebutSIZE);
		Printf_UART(0, "%s", "get wlan\r\n");
		scanf_uart0(rebut, 600);
		//Printf_UART(3,rebut);
		sprintf(parser, "%s", strstr(rebut, "Tx") + 8);
		strtok(parser, "\r\n");
		Printf_UART(3, "El potencia actual es : %s\r\n", parser);
		potencia = (atoi(parser));

	}
	xSemaphoreGive(WiflyMutex);

	return potencia;
}
int wiflyCanviarPotencia(uint32_t potencia) {

	xSemaphoreTake(WiflyMutex, portMAX_DELAY);
	{
		Printf_UART(0, "set wlan tx %d", potencia);
		wiflyConsultaPotencia();

	}
	xSemaphoreGive(WiflyMutex);
	return 1;
}

void wiflyGetIp(void) {

	xSemaphoreTake(WiflyMutex, portMAX_DELAY);
	{
		memset(parser, 0x00, 100);
		memset(rebut, 0x00, rebutSIZE);
		Printf_UART(0, "get ip a\r\n");
		scanf_uart0(rebut, 2500);
		sprintf(parser, "%s", strstr(rebut, "a") + 4);
		strtok(parser, "\r\n");
		Printf_UART(3, "La Ip actual : %s\r\n", parser);
	}
	xSemaphoreGive(WiflyMutex);
}
void wiflyGetChannel(void) {

	xSemaphoreTake(WiflyMutex, portMAX_DELAY);
	{

		memset(parser, 0x00, 100);
		memset(rebut, 0x00, rebutSIZE);
		Printf_UART(0, "%s", "get wlan\r\n");
		scanf_uart0(rebut, 2500);
		sprintf(parser, "%s", strstr(rebut, "han") + 4);
		strtok(parser, "\r\n");
		Printf_UART(3, "El canal actual : %s\r\n", parser);
	}
	xSemaphoreGive(WiflyMutex);
}
int wiflyGetRSSI(void) {

	xSemaphoreTake(WiflyMutex, portMAX_DELAY);
	{

		char*prrsi;
		char RSSI[3];
		memset(parser, 0x00, 100);
		memset(rebut, 0x00, rebutSIZE);
		memset(RSSI, 0x00, 3);
		rssi = 0;
		Printf_UART(0, "%s", "\r\n");
		Printf_UART(0, "%s", "show rssi\r\n");
		scanf_uart0(rebut, 1000);
		sprintf(parser, "%s", strstr(rebut, "RSSI=") + 7);
		strtok(parser, "\r\n");
		Printf_UART(3, "La recepcio : %s\r\n", parser);
		prrsi = parser;

		if (strlen(prrsi) > 0) {
			char *finalrssi;
			finalrssi = prrsi + 1;
			while ((*finalrssi >= 48 && *finalrssi <= 58)) {
				finalrssi++;
			}
			*finalrssi = 0;
			strcpy(RSSI, prrsi);
			rssi = atoi(RSSI);
			commonutilsdelayMS(2500);

			return rssi;
		} else {
			return 0;
		}
	}
	xSemaphoreGive(WiflyMutex);
}
int wiflyElapsedTime(void) {

	xSemaphoreTake(WiflyMutex, portMAX_DELAY);
	{
		memset(parser, 0x00, 100);
		memset(rebut, 0x00, rebutSIZE);
		Printf_UART(0, "%s", "show time\r\n");
		scanf_uart0(rebut, 500);
		sprintf(parser, "%s", strstr(rebut, "U") + 7);
		strtok(parser, "\r\n");
		Printf_UART(3, "El temps transcorregut : %s\r\n", parser);
		char*ptemps;
		char TMPS[3];
		ptemps = parser;

		if (strlen(ptemps) > 0) {
			char *finaltemps;
			finaltemps = ptemps + 1;
			while ((*finaltemps >= 48 && *finaltemps <= 58)) {
				finaltemps++;
			}
			*finaltemps = 0;
			strcpy(TMPS, ptemps);
			rssi = atoi(TMPS);
			return rssi;
		} else {
			return 0;
		}

		return atoi(parser);
	}
	xSemaphoreGive(WiflyMutex);
}
int wiflyParameters(void) {
	wiflyGetIp();
	wiflyGetChannel();
	wiflyGetRSSI();
	wiflyElapsedTime();
	return 1;
}
int wiflyPrintOvertime(void) {

	xSemaphoreTake(WiflyMutex, portMAX_DELAY);
	{
		int rssi = 0, temps = 0, dada_recollida = 0, dmodul8rssi = 0;
		rssi = wiflyGetRSSI();
		commonutilsdelayMS(500);
		temps = wiflyElapsedTime();
		commonutilsdelayMS(250);
		dada_recollida = wiflyCommandesGet();
		commonutilsdelayMS(250);
		dmodul8rssi = (dada_recollida % 8) + temps;
		Printf_UART(3, "RSSI :%d , Temps transcorregut : %d s, Dada : %d \r\n",
				rssi, temps, dada_recollida);
		wiflyCommandesPrintArp(dmodul8rssi);
		commonutilsdelayMS(250);
	}
	xSemaphoreGive(WiflyMutex);
	return 1;
}
